
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class PamatovyCitatDao implements CitatDao {
    private List<Citat> citaty = new LinkedList<Citat>();

    public PamatovyCitatDao() {
        Citat citat1 = new Citat();
        citat1.setId(1);
        citat1.setAutor("Richard P. Feynman");
        citat1.setText("All mass is interaction.");
        citat1.setZdroj("WikiQuote");
        citaty.add(citat1);
        
        Citat citat2 = new Citat();
        citat2.setId(2);
        citat2.setAutor("Rene Descartes");
        citat2.setText("Myslim, teda som.");
        citat2.setZdroj("Internety");
        citaty.add(citat2);
    
    
    }
 
    
    
    @Override
    public Citat najdiPodlaId(Integer id) {
        for (Citat citat : citaty) {
            if(citat.getId().equals(id)) {
                return citat;
            }
        }
        return null;
    }

    @Override
    public List<Citat> najdiPodlaAutora(String autor) {
        List<Citat> najdeneCitaty = new LinkedList<Citat>();
        for (Citat citat : citaty) {
            if(citat.getAutor().equals(autor)) {
                najdeneCitaty.add(citat);
            }
        }
        return najdeneCitaty;       
    }

    @Override
    public List<Citat> najdiPodlaZdroja(String zdroj) {
        List<Citat> najdeneCitaty = new LinkedList<Citat>();
        for (Citat citat : citaty) {
            if(citat.getZdroj().equals(zdroj)) {
                najdeneCitaty.add(citat);
            }
        }
        return najdeneCitaty;       
    }

    @Override
    public List<Citat> listPodlaDatumu() {
        List<Citat> utriedeneCitaty = new ArrayList<Citat>(citaty);
        Collections.sort(utriedeneCitaty, new PodlaDatumuCitatComparator());
        return utriedeneCitaty;
    }

    @Override
    public void save(Citat c) {
        this.citaty.add(c);
    }

    @Override
    public void delete(Citat c) {
        Iterator<Citat> iter = citaty.iterator();
        while(iter.hasNext()) {
            Citat citat = iter.next();
            if(citat.getId().equals(c.getId())) {
                iter.remove();
            }
        }
    }

    private static class PodlaDatumuCitatComparator implements Comparator<Citat> {

        @Override
        public int compare(Citat citat1, Citat citat2) {
            return citat1.getDatum().compareTo(citat2.getDatum());
        }
        
    }
}
