
import java.util.Collections;
import java.util.List;

public class StaleTenIstyCitatDao implements CitatDao {
    public static final String ZDROJ = "BrainyQuote.com";
    private final Citat citat;

    public StaleTenIstyCitatDao() {
        citat = new Citat();
        citat.setAutor("Jorge Luis Borges");
        citat.setText("Život sám o sebe je citátom.");
        citat.setZdroj(ZDROJ);
    }
    
    
    @Override
    public Citat najdiPodlaId(Integer id) {
        return citat;
    }

    @Override
    public List<Citat> najdiPodlaAutora(String autor) {
        if(citat.getAutor().equals(autor)) {
            return Collections.singletonList(citat);
        } else {
            return Collections.EMPTY_LIST;
        }
    }

    @Override
    public List<Citat> najdiPodlaZdroja(String fraza) {
        if(ZDROJ.equals(fraza)) {
            return Collections.singletonList(citat);
        }
        return Collections.EMPTY_LIST;
    }

    @Override
    public List<Citat> listPodlaDatumu() {
        return Collections.singletonList(citat);
    }

    @Override
    public void save(Citat c) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void delete(Citat c) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
       
}
